Attribute VB_Name = "Module1"
Option Explicit
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
' References   SHELLLNK.TLB
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Public Enum SHOWCMDFLAGS
    SHOWNORMAL = 5
    SHOWMAXIMIZE = 3
    SHOWMINIMIZE = 7
End Enum

Public Function fCreateShellLink(sLnkFile As String, _
                                    sExeFile As String, _
                                    sWorkDir As String, _
                                    sExeArgs As String, _
                                    sIconFile As String, _
                                    sDiscrFile As String, _
                                    lIconIdx As Long, _
                                    ShowCmd As SHOWCMDFLAGS) As Long

    ' An explorer IShellLinkA(Win 9x/Win NT) instance
    Dim cShellLink   As ShellLinkA
    ' An explorer IPersistFile instance
    Dim cPersistFile As IPersistFile
        
    If Len(sLnkFile) = 0 Or Len(sExeFile) = 0 Then Exit Function
    
    On Error GoTo fCreateShellLinkError
    'Create new IShellLink interface
    Set cShellLink = New ShellLinkA
    'Implement cShellLink's IPersistFile interface
    Set cPersistFile = cShellLink
    
    With cShellLink
        'Set command line exe name & path to new ShortCut.
        .SetPath sExeFile
        'Set working directory in shortcut
        If Len(sWorkDir) > 0 Then .SetWorkingDirectory sWorkDir
        'Add arguments to command line
        If Len(sExeArgs) > 0 Then .SetArguments sExeArgs
        'Set shortcut description
        If Len(sDiscrFile) > 0 Then .SetDescription sDiscrFile & vbNullChar
        'Set shortcut icon location & index
        If Len(sIconFile) > 0 Then .SetIconLocation sIconFile, lIconIdx
        'Set shortcut's startup mode (min,max,normal)
        .SetShowCmd ShowCmd
    End With
    
    cShellLink.Resolve 0, SLR_UPDATE
    'Unicode conversion that must be done!
    cPersistFile.Save StrConv(sLnkFile, vbUnicode), 0
    'Return Success
    fCreateShellLink = True
    
fCreateShellLinkError:
        Set cPersistFile = Nothing
        Set cShellLink = Nothing
End Function


